package br.com.rjconsultores.auditador.auditadores;

import java.lang.reflect.AccessibleObject;
import java.util.ArrayList;
import java.util.List;

import br.com.rjconsultores.auditador.exceptions.AuditadorException;
import br.com.rjconsultores.auditador.model.AuditadorObjects;

class AuditadorEntidade {

	protected Auditador auditador;

	public AuditadorEntidade(Auditador auditar) {
		super();
		this.auditador = auditar;
	}
	
	public List<AuditadorObjects> auditar(AccessibleObject campo, Object original, Object novo, String nomeClasse) {
		List<AuditadorObjects> lsRetorno = new ArrayList<AuditadorObjects>();
		try {
			Object valorOriginal = campo != null && original != null ? auditador.extrairValor(campo, original) : original;
			Object valorNovo = campo != null && novo != null ? auditador.extrairValor(campo, novo) : novo;
			
			String localNomeClasse = nomeClasse != null ? nomeClasse : auditador.extrairNomeClasse(valorOriginal, valorNovo);
			
			AuditadorObjects objectNovo = auditador.auditarObjetoNovo(campo, valorOriginal, valorNovo);
			if(objectNovo != null) {
				lsRetorno.add(objectNovo);
				return lsRetorno;
			}
			
			if(!auditador.isObjetosNulos(valorOriginal, valorNovo)) {
				Class<?> classe = valorOriginal != null ? valorOriginal.getClass() : valorNovo.getClass();
				List<AccessibleObject> camposAuditaveis = auditador.extrairCamposAuditaveis(classe);
				for (AccessibleObject campoEntidade : camposAuditaveis) {
					String pattern = auditador.extrairPattern(campoEntidade);
				
					Object valorOriginalEntidade = auditador.getValor(campoEntidade, valorOriginal, pattern);
					Object valorNovoEntidade = auditador.getValor(campoEntidade, valorNovo, pattern);
					
					AuditadorObjects auditado = auditador.auditarCampo(campoEntidade, valorOriginalEntidade, valorNovoEntidade, localNomeClasse);
					if(auditado != null) {
						lsRetorno.add(auditado);
					}					
				}
//				Field[] campos = classe.getDeclaredFields();
//				for (Field campoEntidade : campos) {
//					campoEntidade.setAccessible(true);
//					
//					NaoAuditar naoAuditar = auditador.extrairAnotacao.extrairNaoAuditar(campoEntidade);
//					if(naoAuditar != null) {
//						continue;
//					}				
//					
//					AuditarAtributo auditarAtributo =  auditador.extrairAnotacao.extrairAuditarAtributo(campoEntidade);
//					String pattern = auditarAtributo != null && StringUtils.isNotBlank(auditarAtributo.pattern()) ? auditarAtributo.pattern() : null;
//				
//					Object valorOriginalEntidade = auditador.getValor(campoEntidade, valorOriginal, pattern);
//					Object valorNovoEntidade = auditador.getValor(campoEntidade, valorNovo, pattern);
//					
//					AuditadorObjects auditado = auditador.auditarCampo(campoEntidade, valorOriginalEntidade, valorNovoEntidade, localNomeClasse);
//					if(auditado != null) {
//						lsRetorno.add(auditado);
//					}
//				}
			}
		} catch (Exception e) {
			throw new AuditadorException(e.getMessage(), e);
		} catch (Throwable e) {
			throw new AuditadorException(e.getMessage(), e);
		}
		return lsRetorno;
	}

}
