package com.rjconsultores.ventaboletos.blocos.bradesco;

import java.math.BigDecimal;
import java.util.Date;

import com.rjconsultores.ventaboletos.blocos.DadosBoleto;
import com.rjconsultores.ventaboletos.blocos.DetalheObrigatorio;
import com.rjconsultores.ventaboletos.blocos.RateioDeCredito;
import com.rjconsultores.ventaboletos.enuns.TipoInscricaoPagador;

public class DetalheObrigatorioBradesco implements DetalheObrigatorio, Cloneable {

	private Integer idBoletoFechamento;
	private String carteira;
	private String agencia;
	private String contacorrente;
	private String dvConta;
	private String numeroControleDoParticipante;
	private String nossoNumeroComDigito;
	private Integer QtdPagamento = 0;
	private Integer codigoDeOcorrencia = 0;
	private Date dataOcorrencia;
	private String numeroDoDocumento;
	private Date vencimento;
	private BigDecimal valor;
	private String especieDeTitulo;
	private Date emissao;
	private String instrucao1;
	private String instrucao2;
	private BigDecimal valorAtraso = BigDecimal.ZERO;
	private Date dataLimiteDesconto;
	private BigDecimal valorDesconto = BigDecimal.ZERO;
	private BigDecimal valorIOF = BigDecimal.ZERO;
	private BigDecimal valorAbatimentoConcedido = BigDecimal.ZERO;
	private TipoInscricaoPagador tipoInscricaoPagador;
	private String numeroInscricaoPagador;
	private String nomePagador;
	private String enderecoCompletoPagador;
	private String mensagem1;
	private String CEP_Prefixo;
	private String CEP_Sufixo;
	private String sacador_Avalista_Mensagem2;
	private Integer numeroSequencialRegistro;
	private BigDecimal percentualJuros;
	private BigDecimal percentualMulta;

	private DadosBoleto dadosBoleto;

	private RateioDeCredito rateioDeCredito;

	@Override
	public void setIdBoletoFechamento(Integer id) {
		this.idBoletoFechamento = id;

	}

	@Override
	public Integer getIdBoletoFechamento() {
		return this.idBoletoFechamento;
	}

	public String getCarteira() {
		return carteira;
	}

	public void setCarteira(String carteira) {
		this.carteira = carteira;
	}

	public String getAgencia() {
		return agencia;
	}

	public void setAgencia(String agencia) {
		this.agencia = agencia;
	}

	public String getContacorrente() {
		return contacorrente;
	}

	public void setContacorrente(String contacorrente) {
		this.contacorrente = contacorrente;
	}

	public String getDvConta() {
		return dvConta;
	}

	public void setDvConta(String dvConta) {
		this.dvConta = dvConta;
	}

	public String getNumeroControleDoParticipante() {
		return numeroControleDoParticipante;
	}

	public void setNumeroControleDoParticipante(String numeroControleDoParticipante) {
		this.numeroControleDoParticipante = numeroControleDoParticipante;
	}

	public String getNossoNumeroComDigito() {
		return nossoNumeroComDigito;
	}

	public void setNossoNumeroComDigito(String nossoNumeroComDigito) {
		this.nossoNumeroComDigito = nossoNumeroComDigito;
	}

	public Integer getQtdPagamento() {
		return QtdPagamento;
	}

	public void setQtdPagamento(Integer qtdPagamento) {
		QtdPagamento = qtdPagamento;
	}

	public Integer getCodigoDeOcorrencia() {
		return codigoDeOcorrencia;
	}

	public void setCodigoDeOcorrencia(Integer codigoDeOcorrencia) {
		this.codigoDeOcorrencia = codigoDeOcorrencia;
	}

	public Date getDataOcorrencia() {
		return dataOcorrencia;
	}

	public void setDataOcorrencia(Date dataOcorrencia) {
		this.dataOcorrencia = dataOcorrencia;
	}

	public String getNumeroDoDocumento() {
		return numeroDoDocumento;
	}

	public void setNumeroDoDocumento(String numeroDoDocumento) {
		this.numeroDoDocumento = numeroDoDocumento;
	}

	public Date getVencimento() {
		return vencimento;
	}

	public void setVencimento(Date vencimento) {
		this.vencimento = vencimento;
	}

	public BigDecimal getValor() {
		return valor;
	}

	public void setValor(BigDecimal valor) {
		this.valor = valor;
	}

	public String getEspecieDeTitulo() {
		return especieDeTitulo;
	}

	public void setEspecieDeTitulo(String especieDeTitulo) {
		this.especieDeTitulo = especieDeTitulo;
	}

	public Date getEmissao() {
		return emissao;
	}

	public void setEmissao(Date emissao) {
		this.emissao = emissao;
	}

	public String getInstrucao1() {
		return instrucao1;
	}

	public void setInstrucao1(String instrucao1) {
		this.instrucao1 = instrucao1;
	}

	public String getInstrucao2() {
		return instrucao2;
	}

	public void setInstrucao2(String instrucao2) {
		this.instrucao2 = instrucao2;
	}

	public BigDecimal getValorAtraso() {
		return valorAtraso;
	}

	public void setValorAtraso(BigDecimal valorAtraso) {
		this.valorAtraso = valorAtraso;
	}

	public Date getDataLimiteDesconto() {
		return dataLimiteDesconto;
	}

	public void setDataLimiteDesconto(Date dataLimiteDesconto) {
		this.dataLimiteDesconto = dataLimiteDesconto;
	}

	public BigDecimal getValorDesconto() {
		return valorDesconto;
	}

	public void setValorDesconto(BigDecimal valorDesconto) {
		this.valorDesconto = valorDesconto;
	}

	public BigDecimal getValorIOF() {
		return valorIOF;
	}

	public void setValorIOF(BigDecimal valorIOF) {
		this.valorIOF = valorIOF;
	}

	public BigDecimal getValorAbatimentoConcedido() {
		return valorAbatimentoConcedido;
	}

	public void setValorAbatimentoConcedido(BigDecimal valorAbatimentoConcedido) {
		this.valorAbatimentoConcedido = valorAbatimentoConcedido;
	}

	public TipoInscricaoPagador getTipoInscricaoPagador() {
		return tipoInscricaoPagador;
	}

	public void setTipoInscricaoPagador(TipoInscricaoPagador tipoInscricaoPagador) {
		this.tipoInscricaoPagador = tipoInscricaoPagador;
	}

	public String getNumeroInscricaoPagador() {
		return numeroInscricaoPagador;
	}

	public void setNumeroInscricaoPagador(String numeroInscricaoPagador) {
		this.numeroInscricaoPagador = numeroInscricaoPagador;
	}

	public String getNomePagador() {
		return nomePagador;
	}

	public void setNomePagador(String nomePagador) {
		this.nomePagador = nomePagador;
	}

	public String getEnderecoCompletoPagador() {
		return enderecoCompletoPagador;
	}

	public void setEnderecoCompletoPagador(String enderecoCompletoPagador) {
		this.enderecoCompletoPagador = enderecoCompletoPagador;
	}

	public String getMensagem1() {
		return mensagem1;
	}

	public void setMensagem1(String mensagem1) {
		this.mensagem1 = mensagem1;
	}

	public String getCEP_Prefixo() {
		return CEP_Prefixo;
	}

	public void setCEP_Prefixo(String cEP_Prefixo) {
		CEP_Prefixo = cEP_Prefixo;
	}

	public String getCEP_Sufixo() {
		return CEP_Sufixo;
	}

	public void setCEP_Sufixo(String cEP_Sufixo) {
		CEP_Sufixo = cEP_Sufixo;
	}

	public String getSacador_Avalista_Mensagem2() {
		return sacador_Avalista_Mensagem2;
	}

	public void setSacador_Avalista_Mensagem2(String sacador_Avalista_Mensagem2) {
		this.sacador_Avalista_Mensagem2 = sacador_Avalista_Mensagem2;
	}

	public Integer getNumeroSequencialRegistro() {
		return numeroSequencialRegistro;
	}

	public void setNumeroSequencialRegistro(Integer numeroSequencialRegistro) {
		this.numeroSequencialRegistro = numeroSequencialRegistro;
	}

	public DadosBoleto getDadosBoleto() {
		return dadosBoleto;
	}

	public void setDadosBoleto(DadosBoleto dadosBoleto) {
		this.dadosBoleto = dadosBoleto;
	}

	public RateioDeCredito getRateioDeCredito() {
		return rateioDeCredito;
	}

	public void setRateioDeCredito(RateioDeCredito rateioDeCredito) {
		this.rateioDeCredito = rateioDeCredito;
	}

	public BigDecimal getPercentualJuros() {
		return percentualJuros;
	}

	public void setPercentualJuros(BigDecimal percentualJuros) {
		this.percentualJuros = percentualJuros;
	}

	public BigDecimal getPercentualMulta() {
		return percentualMulta;
	}

	public void setPercentualMulta(BigDecimal percentualMulta) {
		this.percentualMulta = percentualMulta;
	}
	
	public String existeMulta() {
		if( this.percentualMulta != null && this.percentualMulta.compareTo(BigDecimal.ZERO) > 0 ) {
			return "2";
		}else {
			return "0";
		}
	}

	public DetalheObrigatorio clone() throws CloneNotSupportedException {
		return (DetalheObrigatorio) super.clone();
	}
}
